//
//  SpinsConfigPanelCtl.m
//  IsingCocoa
//
//  Created by Cameron Hayne on 08/05/05.
//  Copyright Hayne of Tintagel 2005
//
// This program is free software; you can redistribute it and/or
// modify it under the terms of the GNU General Public License
// as published by the Free Software Foundation; either version 2
// of the License, or (at your option) any later version.
//
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
//
// You should have received a copy of the GNU General Public License
// along with this program; if not, write to the Free Software
// Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.

#import "SpinsConfigPanelCtl.h"
#import "IsingWindowCtl.h"
#import "IsingModel.h"

@implementation SpinsConfigPanelCtl

- (id)initForWindowCtl:(IsingWindowCtl *)aWindowCtl
{
    self = [super initWithWindowNibName: @"SpinsConfigPanel"];
    if (self == nil)
    {
        return nil;
    }
    
    //NSLog(@"SpinsConfigPanelCtl.init");
    isingWindowCtl = aWindowCtl;
    mainWindow = [isingWindowCtl window];
    model = [isingWindowCtl model];
    
    [self window]; // force loading of the NIB
    return self;
}

- (void)dealloc
{
    //NSLog(@"SpinsConfigPanelCtl.dealloc");
    [super dealloc];
}

- (void)windowDidLoad
{
    //NSLog(@"SpinsConfigPanelCtl.windowDidLoad");
    IsingInitState defaultInitState = RandomSpins;
    [configPopup selectItemAtIndex: [configPopup indexOfItemWithTag: defaultInitState]];
    
    [NSApp beginSheet: sheet
       modalForWindow: mainWindow
        modalDelegate: nil
       didEndSelector: NULL
          contextInfo: nil];
    
    // We need to retain the SpinsConfigPanelCtl object since it is released
    // in IsingWindowCtl and we need it to stick around until the sheet is closed
    [self retain];
}

- (IBAction)closeSheet:(id)sender
{
    [sheet orderOut: nil];
    [NSApp endSheet: sheet];
    
    // We no longer need the SpinsConfigPanelCtl object
    [self autorelease];

    if (sender != okBtn)
    {
        // user cancelled
        return;
    }
    
    IsingInitState desiredState = [configPopup selectedTag];
    [model setSpinConfig: desiredState];
    [isingWindowCtl setNeedsViewUpdate: YES];
}

@end
