//
//  misc.c
//  IsingCocoa
//
// Created by Cameron Hayne on Fri May 31 2002.
//  Copyright Hayne of Tintagel 2005
//
// This program is free software; you can redistribute it and/or
// modify it under the terms of the GNU General Public License
// as published by the Free Software Foundation; either version 2
// of the License, or (at your option) any later version.
//
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
//
// You should have received a copy of the GNU General Public License
// along with this program; if not, write to the Free Software
// Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.

#include "ising.h"
#include "misc.h"
#include <assert.h>
#include <stdlib.h>

void *myMalloc(size_t numBytes)
{
    void *ptr = malloc(numBytes);
    assert(ptr != 0);
    return ptr;
}

void *myCalloc(size_t numItems, size_t itemSize)
{
    void *ptr = calloc(numItems, itemSize);
    assert(ptr != 0);
    return ptr;
}

void *myRealloc(void *ptr, size_t numBytes)
{
    void *newptr = realloc(ptr, numBytes);
    assert(newptr != 0);
    return newptr;
}

void myFree(void *ptr)
{
    free(ptr);
}



