//
//  BlockSpinView.m
//  IsingCocoa
//
//  Created by Cameron Hayne on 21/04/05.
//  Copyright Hayne of Tintagel 2005
//
// This program is free software; you can redistribute it and/or
// modify it under the terms of the GNU General Public License
// as published by the Free Software Foundation; either version 2
// of the License, or (at your option) any later version.
//
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
//
// You should have received a copy of the GNU General Public License
// along with this program; if not, write to the Free Software
// Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.

#import "BlockSpinView.h"
#import "IsingSpinView.h"

@implementation BlockSpinView

- (id)initWithFrame:(NSRect)frame
{
    NSRect viewFrame = NSMakeRect(0, 0, frame.size.width, frame.size.height);
    
    self = [super initWithFrame: frame];
    if (self == nil)
        return nil;

    //NSLog(@"BlockSpinView: init");
    [self setContentViewMargins: NSMakeSize(0, 0)];
    [self setBorderType: NSNoBorder];
    
    mySpinView = [[IsingSpinView alloc] initWithFrame: viewFrame];
    
    [self addSubview: mySpinView];
    [self sizeToFit];
    
    return self;
}

- (void)dealloc
{
    //NSLog(@"BlockSpinView: dealloc");
    [mySpinView release];
    [super dealloc];
}

- (void)setSpinViewSize:(NSSize)size
{
    [mySpinView setFrameSize: size];
    [self sizeToFit];
}

- (void)updateIsingViewSpinsSize:(IsingSize)size
{
    [self setTitle: [NSString stringWithFormat: @"%d x %d  ",
                                                size.width, size.height]];
    [mySpinView updateIsingViewSpinsSize: size];
}

- (void)updateIsingViewSpins:(Spins *)spins
{
    [mySpinView updateIsingViewSpins: spins];
}

// we need this to conform to the <IsingView> protocol
- (NSWindow *)isingViewWindow
{
    return [mySpinView window];
}

@end
